<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_Seat ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_Seat extends AbstractStructArrayBase
{
    /**
     * The Seat
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_Seat[]
     */
    public $Seat;
    /**
     * Constructor method for ArrayOfJP_Seat
     * @uses ArrayOfJP_Seat::setSeat()
     * @param \StructType\JP_Seat[] $seat
     */
    public function __construct(array $seat = array())
    {
        $this
            ->setSeat($seat);
    }
    /**
     * Get Seat value
     * @return \StructType\JP_Seat[]|null
     */
    public function getSeat()
    {
        return $this->Seat;
    }
    /**
     * Set Seat value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_Seat[] $seat
     * @return \ArrayType\ArrayOfJP_Seat
     */
    public function setSeat(array $seat = array())
    {
        foreach ($seat as $arrayOfJP_SeatSeatItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_SeatSeatItem instanceof \StructType\JP_Seat) {
                throw new \InvalidArgumentException(sprintf('The Seat property can only contain items of \StructType\JP_Seat, "%s" given', is_object($arrayOfJP_SeatSeatItem) ? get_class($arrayOfJP_SeatSeatItem) : gettype($arrayOfJP_SeatSeatItem)), __LINE__);
            }
        }
        $this->Seat = $seat;
        return $this;
    }
    /**
     * Add item to Seat value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_Seat $item
     * @return \ArrayType\ArrayOfJP_Seat
     */
    public function addToSeat(\StructType\JP_Seat $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_Seat) {
            throw new \InvalidArgumentException(sprintf('The Seat property can only contain items of \StructType\JP_Seat, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Seat[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_Seat|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_Seat|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_Seat|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_Seat|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_Seat|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Seat
     */
    public function getAttributeName()
    {
        return 'Seat';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_Seat
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
